# Deal with differing "which" semantics
mywhich() {
    which "$1" 2>/dev/null | grep -v "no $1"
}

# Check platform
ostype=`uname -s`
if test "$ostype" != "Linux" && test "$ostype" != "SunOS" ; then
  echo "Linux/Solaris not detected."
  exit 1
fi

# Get the package management tool
for gxti in "apt" "yum" "dnf" "dpkg" "pacman" "zypper"; do
    set $gxti
    gxtpath="`mywhich $1`"
    case "$gxtpath" in ?*)
        cmd="$gxtpath"
        ;;
    esac
done

# Install dependency libraries
# Package Search: https://packages.ubuntu.com/
packages_apt="libadwaita libgtksourceview-5 libssh2-1 openssl libsoup-3.0 libarchive uchardet libqrencode4"

# Package Search: https://pkgs.org/
packages_yum="libadwaita-1 gtksourceview5 libssh2 openssl libsoup3 libarchive uchardet libqrencode"
packages_dnf="libadwaita-1 gtksourceview5 libssh2 openssl libsoup3 libarchive uchardet libqrencode"

# Package Search: https://packages.debian.org/search?keywords=search
packages_dpkg="libadwaita-1 libgtksourceview-5-0 libssh2-1 openssl libsoup-3.0 libarchive uchardet libqrencode4"

# Package Search: https://archlinux.org/packages/
packages_pacman="libadwaita gtksourceview5 libssh2 openssl libsoup3 libarchive uchardet qrencode"

# Package Search: https://software.opensuse.org/find
packages_zypper="libadwaita gtksourceview5 libssh2-1 openssl libsoup-3 libarchive uchardet libqrencode4"
case "$cmd" in
    *"pacman"*)
        for name in $packages_pacman; do
            sudo $cmd -S $name
        done
        ;;
    *"apt"*)
        for name in $packages_apt; do
            sudo $cmd install $name
        done
        ;;
    *"yum"*)
        for name in $packages_yum; do
            sudo $cmd install $name
        done
        ;;
    *"dnf"*)
        for name in $packages_dnf; do
            sudo $cmd install $name
        done
        ;;
    *"dpkg"*)
        for name in $packages_dpkg; do
            sudo $cmd -i $name
        done
        ;;
    *"zypper"*)
        for name in $packages_zypper; do
            sudo $cmd install $name
        done
        ;;
esac